#!/usr/bin/python
# -*- coding: utf-8 -*-
from Imports import *
from string import *
import urllib, re

from Plugins.Extensions.VlcPlayer.VlcServerConfig import vlcServerConfig

urlBase = "http://www.rai.tv/%s"
urlBaseThemes = "http://www.rai.tv/dl/RaiTV/cerca_tematiche.html?%s"
urlListItems = "http://www.rai.tv/dl/RaiTV/programmi/liste/%s-V-%s.html"

def listThemes():
  items = []
#  data = urllib.urlopen(urlBaseThemes % ("Nope")).read()
  url = "http://www.rai.tv/dl/RaiTV/cerca_tematiche.html"
  data = urllib.urlopen(url).read()
  result = re.findall("<a title=\".*?\" href=\"\?(.*?)\">.*</a>", data)
  for item in result:
    items.append(str(item))
    
  return items
  
  
def listThemeItems(theme):
  items = []
  print("listThemeItems: Theme %s" % (theme))
  url = "http://www.rai.tv/dl/RaiTV/cerca_tematiche.html?" + theme
  print "url =", url
  data = urllib.urlopen(url).read()
  
  ''' Remove newline char and simplify the regexp'''
  data = data.replace("\n","")
  result = re.findall("<a href=\"(\/dl.*?)\">.*?<div class=\"internal\">(.*?)</div>", data)
  print "result =", result
  for item in result:
    items.append(item)
  return items

''' Return a list with <list-url> and <description> of each sub-section '''
  
''' Return a list with <url> and <description> of each video '''
def listItems(startURL):
  items = []
  print("listItems: startURL %s" % (startURL))
  page = 0
  while(True):
    data = urllib.urlopen(startURL).read()
    if data.find("404 Not Found") > 0:
      print("listItems: startURL %s stopped at page %s" % (startURL,page))
      return items
      
    data = data.replace("\n","")
    result = re.findall("<a .*?href=\"(/dl/RaiTV/programmi/media/ContentItem.*?)\".*?><h2>(.*?)</h2>", data)
    for item in result:
      items.append(item)
#    page += 1
    return items

    
def openMovie(url):
    print("openMovie: URL " + url)
    data = urllib.urlopen(url).read()
    result = re.findall("videoURL = \"(.*?)\"", data, re.DOTALL)
    return result[0]


    
#################

class RAI(Screen):
    def __init__(self, session):
		
		Screen.__init__(self, session)
                self.skin = SkinList2.skin
		title = "RAI"
		self["title"] = Button(title)

        	self["list"] = MenuList([])
		self["info"] = Label()
		self["KEY_HELP"] = Button(_("HELP"))
                self["actions"] = ActionMap(["OkCancelActions",], {"ok": self.okClicked, "cancel": self.cancel, }, -1)
                self.srefOld = self.session.nav.getCurrentlyPlayingServiceReference()
		global SREF
                SREF = self.srefOld
                self.ict = 0
                self.names = []       
                self.urls = []  
                self.onLayoutFinish.append(self.startSession)

    def cancel(self):
                self.session.nav.playService(SREF)
                self.close()

    def startSession(self):

                shows = []
                shows = listThemes()
                print "shows = ", shows
#                 shows = listThemeItems("Spettacolo")
#                 print "shows = ", shows


#                 url = "http://www.rai.tv/dl/RaiTV/programmi/Page-d33022ea-4131-4297-9062-2eeda0ff312a.html"
#                 shows = listItems(url)
#                 print "shows = ", shows
#                 url = 'http://www.rai.tv/dl/RaiTV/programmi/media/ContentItem-4f995eb4-cb3e-4439-bc46-053f67372ad0.html#p=0'
#                 vidurl = openMovie(url)
#                 print "vidurl = ", vidurl

                self.names = shows
                self["info"].setText("")
                #print "self.names =", self.names
                self["list"].setList(self.names)                 
                 
    
    def okClicked(self):
          itype = self["list"].getSelectionIndex()
          #print "itype = ", itype
          if itype is not None: 
                name = self.names[itype]
                #print "Myvideo url =", url
                self.session.open(Shows, name)
                

############ 
class Shows(Screen):
    def __init__(self, session, theme):
		
		Screen.__init__(self, session)
                self.skin = SkinList2.skin
		title = "Themes"
		self["title"] = Button(title)

        	self["list"] = MenuList([])
		self["info"] = Label()
		self["KEY_HELP"] = Button(_("HELP"))
                self["actions"] = ActionMap(["OkCancelActions",], {"ok": self.okClicked, "cancel": self.cancel, }, -1)
                self.srefOld = self.session.nav.getCurrentlyPlayingServiceReference()
		global SREF
                SREF = self.srefOld
                self.ict = 0
                self.theme = theme
                self.names = []       
                self.urls = []  
                self.onLayoutFinish.append(self.startSession)

    def cancel(self):
                self.session.nav.playService(SREF)
                self.close()

    def startSession(self):
                self.shows = []
                self.shows = listThemeItems(self.theme)
#                print "shows = ", shows

                self["info"].setText("")
                n1 = len(self.shows)
                i = 0
                while i<n1: 
                       self.names.append(self.shows[i][1])
                       url = "http://www.rai.tv" + self.shows[i][0]
                       self.urls.append(url)
                       i= i+1 
                print "self.names =", self.names
                print "self.urls =", self.urls
                self["list"].setList(self.names)

    
    def okClicked(self):
          itype = self["list"].getSelectionIndex()
          #print "itype = ", itype
          if itype is not None: 
                url = self.urls[itype]
                #print "Subcat url =", url
                self.session.open(Getvids, url)

                
############ 
class Getvids(Screen):
    def __init__(self, session, url):
		
		Screen.__init__(self, session)
                self.skin = SkinList2.skin
		title = "Videos"
		self["title"] = Button(title)

        	self["list"] = MenuList([])
		self["info"] = Label()
		self["KEY_HELP"] = Button(_("HELP"))
                self["actions"] = ActionMap(["OkCancelActions",], {"ok": self.okClicked, "cancel": self.cancel, }, -1)
                self.srefOld = self.session.nav.getCurrentlyPlayingServiceReference()
		global SREF
                SREF = self.srefOld
                self.ict = 0
                self.url = url
                self.names = []       
                self.urls = []  
                self.onLayoutFinish.append(self.startSession)

    def cancel(self):
                self.session.nav.playService(SREF)
                self.close()

    def startSession(self):
                self.vids = []
                self.vids = listItems(self.url)
#                print "shows = ", shows

                self["info"].setText("")
                n1 = len(self.vids)
                i = 0
                while i<n1: 
                       self.names.append(self.vids[i][1])
                       url = self.vids[i][0]
                       self.urls.append(url)
                       i= i+1 
                print "self.names =", self.names
                print "self.urls =", self.urls
                self["list"].setList(self.names)


    
    def okClicked(self):
          itype = self["list"].getSelectionIndex()
          #print "itype = ", itype
          if itype is not None: 
                url = "http://www.rai.tv" + self.urls[itype]
                #print "Getpath url =", url
                self.vidurl = openMovie(url)
                print "self.vidurl = ", self.vidurl
                self.name = self.names[itype]
                self.test()


    def test(self):
			self.serverList = vlcServerConfig.getServerlist()
			if len(self.serverList) == 0:
				self.session.open(MessageBox, "No server configured in VlcPlayer Plugin!", MessageBox.TYPE_ERROR)
			elif len(self.serverList) == 1:
				self.playfile(0)
			else:
				self.playfile(0)
	
	
    def playfile(self, serverint):
			self.serverList[serverint].play(self.session, self.vidurl, self.name)



#################################################

def main(session, **kwargs):
	session.open(RAI)

def Plugins(**kwargs):
	return [
		PluginDescriptor(name = "RAI", description = _("RAI Videos"), where = PluginDescriptor.WHERE_PLUGINMENU, fnc = main),
		PluginDescriptor(name = "RAI", description = _("RAI videos"), where = PluginDescriptor.WHERE_EXTENSIONSMENU, fnc=main)]









