from Imports import *
import urllib2
import httplib
import urlparse
#################
import os, re, sys
#import urllib, urllib2, HTMLParser
import urllib, urllib2
#import xbmcgui, xbmcplugin, xbmcaddon
#from mindmade import *
import simplejson
from BeautifulSoup import BeautifulSoup

#
# constants definition
############################################
#PLUGINID = "plugin.video.sf-videoportal"

# plugin handle
#pluginhandle = int(sys.argv[1])

# plugin modes
MODE_SENDUNGEN       = "sendungen"
MODE_SENDUNGEN_ALLTOPICS = "sendungen_alltopics"
MODE_SENDUNGEN_TOPIC = "sendungen_topic"
MODE_SENDUNG         = "sendung"
MODE_SENDUNG_PREV    = "sendung_prev"
MODE_VERPASST        = "verpasst"
MODE_VERPASST_DETAIL = "verpasst_detail"
MODE_CHANNEL_LIST    = "channel_list"
MODE_CHANNEL         = "channel"
MODE_PLAY            = "play"

# parameter keys
PARAMETER_KEY_MODE = "mode"
PARAMETER_KEY_ID = "id"
PARAMETER_KEY_PAGE = "page"
PARAMETER_KEY_URL = "url"
PARAMETER_KEY_TITLE = "title"
PARAMETER_KEY_POS   = "pos"

ITEM_TYPE_FOLDER, ITEM_TYPE_VIDEO = range(2)
BASE_URL = "http://www.videoportal.sf.tv"
FLASH_PLAYER = "http://www.videoportal.sf.tv/flash/videoplayer.swf"

#settings = xbmcaddon.Addon( id=PLUGINID)

#LIST_FILE = os.path.join( settings.getAddonInfo( "path"), "resources", "list.dat")
listItems = []

#
# utility functions
############################################

# Log NOTICE

UA = ('Mozilla/5.0 (Windows; U; Windows NT 6.0; en-US) '
      'AppleWebKit/535.1 (KHTML, like Gecko) '
      'Chrome/13.0.782.6 Safari/535.1')

#def __get_url(url, referer=None):
def fetchHttp(url, referer=None):
    print '__get_url opening url', url
    req = urllib2.Request(url)
    if referer:
        req.add_header('Referer', referer)
    req.add_header('Accept', ('text/html,application/xhtml+xml,'
                              'application/xml;q=0.9,*/*;q=0.8'))
    req.add_header('User-Agent', UA)
    html = urlopen(req).read()
    print '__get_url got bytes', len(html)
    return html



def parameters_string_to_dict( parameters):
    ''' Convert parameters encoded in a URL to a dict. '''
    paramDict = {}
    if parameters:
        paramPairs = parameters[1:].split("&")
        for paramsPair in paramPairs:
            paramSplits = paramsPair.split('=')
            if (len(paramSplits)) == 2:
                paramDict[paramSplits[0]] = urllib.unquote( paramSplits[1])
    return paramDict


#
# parsing functions
############################################

def getIdFromUrl( url):
    return re.compile( 'id=([0-9a-z\-]+)').findall( url)[0]


def getJSONForId( id):
    json_url = BASE_URL + "/cvis/segment/" + id + "/.json?nohttperr=1;omit_video_segments_validity=1;omit_related_segments=1"
    json = simplejson.loads( fetchHttp( json_url).split( "\n")[1])
    return json


def getVideoFromJSON( json):
    streams = json["streaming_urls"]
    sortedstreams = sorted( streams, key=lambda el: int(el["bitrate"]))
    print "sortedstreams =", sortedstreams
    
    quality = 2
    
    return '"' + sortedstreams[ quality]["url"] + '"' + ' --start=0 --swfVfy=1 --swfUrl="' + FLASH_PLAYER + '"'



def getThumbnailForId( id):
    thumb = BASE_URL + "/cvis/videogroup/thumbnail/" + id + "?width=200"
    return thumb


#
# content functions
############################################

def list_prev_sendungenX( sendid, soup, alreadylisted=0, selected=0):
    log( "listpref: sendung-id: %s" % sendid)
    global listItems
    doAppend = (alreadylisted==0)
    listed=0;
    if doAppend:
        items=simplejson.load( file( LIST_FILE, "r"))
        for item in items:
            title, params, thumb = item
            addDirectoryItem( ITEM_TYPE_VIDEO, title, params, thumb)
            listed = listed+1

    previous = soup.find( "div", "prev_sendungen")
    shows = previous.findAll( "div", "comment_row")
    for show in shows:
        a = show.find( "a", "sendung_title")
        if (a):
            title = a.strong.string
            id = getIdFromUrl( a['href'])
            thumb = re.sub( '\?width=[0-9]+', '?width=200', show.find( "a").img['src'])

            addDirectoryItem( ITEM_TYPE_VIDEO, title, {PARAMETER_KEY_MODE: MODE_PLAY, PARAMETER_KEY_ID: id}, thumb, len( shows) + listed + alreadylisted)

    # check for more 'history'
    nextpage = None
    baseurl = BASE_URL + "/sendung"
    pagination = soup.find( "p", "pagination")
    if (pagination):
        log( "pagination")
        # check for next page
        r = pagination.find( "a", "act")
        if (r):
            log( "act")
            curpage = int(r.text)
            numpages = len( pagination.findAll( "a")) - 1
            log( "on page %d/%d" % (curpage, numpages))

            if (curpage < numpages):
                nextpage = curpage+1;

    if not nextpage:
        nexturl = BASE_URL + soup.find( "div", "grey_box sendung_nav").find( "a")["href"]

    if nextpage:
        log( "nextpage: %d" % nextpage)
        addDirectoryItem( ITEM_TYPE_FOLDER, "mehr...", {PARAMETER_KEY_ID: sendid, PARAMETER_KEY_PAGE: str(nextpage), PARAMETER_KEY_MODE: MODE_SENDUNG_PREV, PARAMETER_KEY_POS: str( len(listItems)+1)})

    # signal end of list
    xbmcplugin.endOfDirectory(handle=pluginhandle, succeeded=True, updateListing=doAppend)

    # scroll list to bottom and select first new element
    if (selected):
        window = xbmcgui.Window(xbmcgui.getCurrentWindowId())
        window.getControl(50).selectItem( len(listItems)+1)
        window.getControl(50).selectItem( int(selected))

    # store listed items
    simplejson.dump( listItems, file( LIST_FILE, "w"))


#
# mode handlers
############################################

def show_root_menuX():
    addDirectoryItem( ITEM_TYPE_FOLDER, "Sendungen", {PARAMETER_KEY_MODE: MODE_SENDUNGEN})
    addDirectoryItem( ITEM_TYPE_FOLDER, "Sendungen nach Thema", {PARAMETER_KEY_MODE: MODE_SENDUNGEN_ALLTOPICS})
    addDirectoryItem( ITEM_TYPE_FOLDER, "Sendung verpasst?", {PARAMETER_KEY_MODE: MODE_VERPASST})
    addDirectoryItem( ITEM_TYPE_FOLDER, "Channels", {PARAMETER_KEY_MODE: MODE_CHANNEL_LIST})
    xbmcplugin.endOfDirectory(handle=pluginhandle, succeeded=True)


def show_sendungen():
    url = BASE_URL + "/sendungen"
    soup = BeautifulSoup( fetchHttp( url))
    names = []
    ids = []
    
    for show in soup.findAll( "div", "az_row"):
        url = show.find( "a")['href']
        title = show.find( "img", "az_thumb")['alt']
        id = getIdFromUrl( url)
        image = getThumbnailForId( id)
        print "title =", title
        print "id =", id
        names.append(str(title))
        ids.append(str(id))
    return ids, names    
#        addDirectoryItem( ITEM_TYPE_FOLDER, title, {PARAMETER_KEY_MODE: MODE_SENDUNG, PARAMETER_KEY_ID: id }, image)

#    xbmcplugin.endOfDirectory(handle=pluginhandle, succeeded=True)


def show_sendungen_alltopics():
    url = BASE_URL + "/sendungen"
    soup = BeautifulSoup( fetchHttp( url, { "sort": "topic"}))

    for topic in soup.findAll( "div", "grey_box"):
        title = topic.find("h2").string
#        addDirectoryItem( ITEM_TYPE_FOLDER, title, {PARAMETER_KEY_MODE: MODE_SENDUNGEN_TOPIC, PARAMETER_KEY_ID: title})

#    xbmcplugin.endOfDirectory(handle=pluginhandle, succeeded=True)


def show_sendungen_topic( params):
    url = BASE_URL + "/sendungen"
    selected_topic = params.get( PARAMETER_KEY_ID)
    soup = BeautifulSoup( fetchHttp( url, {"sort": "topic"}))

    for topic in soup.findAll( "div", "az_unit"):
        t = topic.find("h2").string
        print t
        if (t == selected_topic):
            for show in topic.findAll( "div", "az_row"):
                url = show.find( "a")['href']
                title = show.find( "img", "az_thumb")['alt']
                id = getIdFromUrl( url)
                image = getThumbnailForId( id)
                addDirectoryItem( ITEM_TYPE_FOLDER, title, {PARAMETER_KEY_MODE: MODE_SENDUNG, PARAMETER_KEY_ID: id}, image)
            break

    xbmcplugin.endOfDirectory(handle=pluginhandle, succeeded=True)

def show_sendung( params):
    sendid = params.get( PARAMETER_KEY_ID)
    url = BASE_URL + "/sendung"
    soup = BeautifulSoup( fetchHttp( url, { "id": sendid }))

    # current show
    show = soup.find( "div", "act_sendung_info")
    a = show.find( "a", { "class": None})
    title = a.string
    id = getIdFromUrl( a['href'])
    thumb = re.sub( '\?width=\\d+', '?width=200', show.find( "a").img['src'])
#    addDirectoryItem( ITEM_TYPE_VIDEO, title, {PARAMETER_KEY_MODE: MODE_PLAY, PARAMETER_KEY_ID: id}, thumb)

    # previous shows
#    listed = list_prev_sendungen( sendid, soup, 1)

def show_prev_sendung( params):
    id = params.get( PARAMETER_KEY_ID)
    page = params.get( PARAMETER_KEY_PAGE)
    url = BASE_URL + "/sendung"
    log( "id: %s" % id)
    log( "page: %s" % page)
    soup = BeautifulSoup( fetchHttp( url, { "id": id, "page": page }))
    list_prev_sendungen( id, soup, selected=params.get( "pos"))

def show_verpasst():
    url = BASE_URL + "/verpasst"
    html = fetchHttp( url)
    match = re.compile( '<a class="day_line.+?href="(.+?)"><span class="day_name">(.+?)</span><span class="day_date">(.+?)</span></a>').findall( html.replace( "\n", ""))
    for url,name,date in match:
        title = "%s, %s" % (date, name.strip())
        addDirectoryItem( ITEM_TYPE_FOLDER, title, {PARAMETER_KEY_MODE: MODE_VERPASST_DETAIL, PARAMETER_KEY_URL: url})

    xbmcplugin.endOfDirectory(handle=pluginhandle, succeeded=True)


def show_verpasst_detail( params):
    url = BASE_URL + "/verpasst" + params.get( PARAMETER_KEY_URL)
    soup = BeautifulSoup( fetchHttp( url))
    day = soup.find( "div", "sendungen_missed_column")
    if "inact" in day["class"]:
        day = soup.findAll( "div", "sendungen_missed_column")[1]
    shows =  day.findAll( "div", "sendung_item")
    for show in shows:
        url = show.find( "a")["href"]
        name = show.find( "img")["title"]
        thumb = re.sub( '\?width=[0-9]+', '?width=200', show.find( "img")["src"])
        time = show.find( "p", "time").string
        id = getIdFromUrl( url)
        title = "%s, %s" % (time, name)
        addDirectoryItem( ITEM_TYPE_VIDEO, title, {PARAMETER_KEY_MODE: MODE_PLAY, PARAMETER_KEY_ID: id}, thumb, len( shows))

    xbmcplugin.endOfDirectory(handle=pluginhandle, succeeded=True)


def show_channel_list():
    url = BASE_URL + "/channels"
    soup = BeautifulSoup( fetchHttp( url))
    channels = soup.findAll( "h2", "hidden")
    for ch in channels:
        title = re.sub( "Channel\s+Channel", "Channel", ch.string)
        link = BASE_URL + ch.parent.find( "a")["href"]
        thumb = BASE_URL + ch.parent.find( "img")["src"]
        addDirectoryItem( ITEM_TYPE_FOLDER, title, {PARAMETER_KEY_MODE: MODE_CHANNEL, PARAMETER_KEY_URL: link}, thumb, len( channels))
    xbmcplugin.endOfDirectory(handle=pluginhandle, succeeded=True)


def show_channel( params):
    url = params.get( PARAMETER_KEY_URL)
    soup = BeautifulSoup( fetchHttp( url))
    items = soup.find( "div", "scroll-pane").findAll( "div", "teaser_item")
    for item in items:
        a = item.findAll( "a")[1]
        title = a.string
        id = getIdFromUrl( a["href"])
        thumb = re.sub( '\?width=\\d+', '?width=200', item.find( "img")["src"])
        addDirectoryItem( ITEM_TYPE_FOLDER, title, {PARAMETER_KEY_MODE: MODE_PLAY, PARAMETER_KEY_ID: id}, thumb, len( items))
    xbmcplugin.endOfDirectory(handle=pluginhandle, succeeded=True)
        

#
# xbmc entry point
############################################



#################
#*******************#

class SF(Screen):
    def __init__(self, session):
		
		Screen.__init__(self, session)
                self.skin = SkinList2.skin
		title = "MyVideo.de"
		self["title"] = Button(title)

        	self["list"] = MenuList([])
		self["info"] = Label()
		self["KEY_HELP"] = Button(_("HELP"))
                self["actions"] = ActionMap(["OkCancelActions",], {"ok": self.okClicked, "cancel": self.cancel, }, -1)
                self.srefOld = self.session.nav.getCurrentlyPlayingServiceReference()
		global SREF
                SREF = self.srefOld
                self.ict = 0
                self.names = []       
                self.urls = []  
                self.onLayoutFinish.append(self.startSession)

    def cancel(self):
                self.session.nav.playService(SREF)
                self.close()

    def startSession(self):
                self.urls, self.names = show_sendungen()
                
                self["info"].setText(" ")
                
                print "self.names =", self.names
                print "self.urls =", self.urls
                self["list"].setList(self.names)                
                
                

    def okClicked(self):
          itype = self["list"].getSelectionIndex()
          #print "itype = ", itype
          if itype is not None: 
                url = self.urls[itype]
                #print "Myvideo url =", url
                self.session.open(Getshows, url)
                
class Getshows(Screen):


    def __init__(self, session, url):
		Screen.__init__(self, session)
                self.skin = SkinList2.skin
		title = "Shows"
		self["title"] = Button(title)

        	self["list"] = MenuList([])
		self["info"] = Label()
		self["key_red"] = Button(_("Exit"))
		self["key_green"] = Button(_("Play"))
                self["setupActions"] = ActionMap(["SetupActions", "ColorActions", "TimerEditActions"],
		{
			"red": self.close,
			"green": self.okClicked,
			"cancel": self.close,
			"ok": self.okClicked,
		}, -2)
                self.srefOld = self.session.nav.getCurrentlyPlayingServiceReference()
		global SREF
                SREF = self.srefOld
                
                self.icount = 0
                self.url = "http://www.videoportal.sf.tv/sendung?id=" + url
                self.urls = []
                self.names = []
                #print " self.url =", self.url
                self.onLayoutFinish.append(self.search)
                
    def search(self):
           self["info"].setText("Downloading list...")
           furl = self.url
           #print "GetSerien furl =", furl
           getPage(self.url, agent=config.plugins.webmedia.useragent.value).addCallback(self.downloadListCallback).addErrback(self.downloadListError)

    def downloadListError(self, error=""):
		#print str(error)
		self["info"].setText("Connection Error!")

    def downloadListCallback(self, fpage=""):
#           #print "GetSerien fpage =", fpage

           iname = []
           surl = []
           self.names = []
           self.urls = []

	   i = 0
	   j = 0
	   icount = 0
	   start = 0
           
           while i<50 :
                n0 = fpage.find('sendung_content',start)
                if n0<0:
                       i = i+1
                       break 
                n11 = fpage.find('strong',(n0+5))
                if n11<0:
                       i = i+1
                       break        
                n1 = fpage.find('<',(n11+7))
                if n1<0:
                       i = i+1
                       break
                n2 = fpage.find("video?id",(n1+5))
                if n2<0:
                       i = i+1
                       break
                n21 = fpage.find(';',(n2+2))
                if n21<0:
                       i = i+1
                       break
                self.names.append(i)
                self.names[i] = fpage[(n11+7):(n1)]
                self.urls.append(i)
                self.urls[i] = fpage[(n2+9):(n21)]
                #print "GetSerien i, self.names[i], self.urls[i] =", i, self.names[i], self.urls[i]                 

                start = n21+10
                i = i+1
                
           self["info"].setText("")
           self["list"].setList(self.names)
           
                     
          
   
    def keyLeft(self):
		self["text"].left()
	
    def keyRight(self):
		self["text"].right()
    def okClicked(self):
                idx = self["list"].getSelectionIndex()
#           try:
                url = self.urls[idx]
                vid = self.names[idx]
                print "vid, url =", vid, url
                id = url
                json = getJSONForId( id)
                vidurl = getVideoFromJSON( json)
                if "mark_in" in json.keys( ):
                         start = json["mark_in"]
                elif "mark_in" in json["video"]["segments"][0].keys():
                         start = json["video"]["segments"][0]["mark_in"]
                else: start = 0
                desc = " "
                print "vidurl = ", vidurl 
                self.session.open(Showrtmp, vid, vidurl, desc)
    
    def keyLeft(self):
		self["text"].left()
	
    def keyRight(self):
		self["text"].right()
	
    def keyNumberGlobal(self, number):
		#print "pressed", number
		self["text"].number(number)
                
############ 
               
class Showrtmp(Screen):

    def __init__(self, session, name, url, desc):
		Screen.__init__(self, session)
#                self.skin = SkinA.skin
                self.skin = SkinC.skin
                title = "Play"
                self.setTitle(title)

        	self["list"] = MenuList([])
		self["info"] = Label()
                self["key_red"] = Button(_("Exit"))
		self["key_green"] = Button(_("Download"))
		self["key_yellow"] = Button(_("Play"))
		self["key_blue"] = Button(_("Stop Download"))
                self["setupActions"] = ActionMap(["SetupActions", "ColorActions", "TimerEditActions"],
		{
			"red": self.close,
			"green": self.okClicked,
			"yellow": self.play,
			"blue": self.stopdl,
			"cancel": self.cancel,
			"ok": self.okClicked,
		}, -2)
                self.icount = 0
#                self.ict = 0
                #print "Showrtmp : name =", name
                self.name = name
                self.url = url
#                self["info"].setText("Must do (1) Download  (2) Play. \n\nVideo selected :-  " + self.name)
                txt = "Must do (1) Download  (2) Play.\n\n" + self.name + "\n\n" + desc
                self["info"].setText(txt)

                self.srefOld = self.session.nav.getCurrentlyPlayingServiceReference()
                self.onLayoutFinish.append(self.getrtmp)

    def getrtmp(self):
#            try:           
                       #print "Showtrmp self.url =", self.url
                       fold = config.plugins.webmedia.cachefold.value
                       fname = self.name.replace(" ", "-")
                       fname = fname.replace("/", "-")
                       svfile = fold + "/Video1.mp4"
                       self.svf = svfile
                       cmd = "rm " + svfile
                       os.system(cmd)
                       self.urtmp = "rtmpdump -r " + self.url + " -o '" + svfile + "'"
                       print "self.urtmp = ", self.urtmp         


#            except:
#                    self.close()
                    

    def okClicked(self):
                self["info"].setText("Downloading ....")
                svfile = self.svf


#                cmd = "rtmpdump -r " + "'" + self.url + "'" + " -n " + "'" + self.urln + "'" + " -y " + "'" + self.urly + "'" + " -a " + "'" + self.urla + "'" + " -o " + "'" + svfile + "' &"
#                #print "cmd = ", cmd 
                cmd = "rm " + svfile
                os.system(cmd)
                #print "Going Into JobManager"
                JobManager.AddJob(downloadJob(self, self.urtmp, svfile, 'Title 1')) 
                
                self.LastJobView()

 
    def LastJobView(self):
		currentjob = None
		for job in JobManager.getPendingJobs():
			currentjob = job

		if currentjob is not None:
			self.session.open(JobView, currentjob)
 
    def play(self):
          if os.path.exists(self.svf):
                #print "Showrtmp here 2"
                svfile = self.svf
                print "svfile play= ", svfile
                pvd = Playvid(self.session, self.name, svfile)
                pvd.openTest()
         
          else:      
                txt = "Download Video first."
                self["info"].setText(txt)
                
    
    def cancel(self):
#	        self.session.nav.playService(self.srefOld)
                self.session.nav.playService(SREF)                
                self.close()

    def stopdl(self):
                svfile = self.svf
                cmd = "rm " + svfile
                os.system(cmd)                
                self.session.nav.playService(self.srefOld)
                cmd1 = "killall -9 rtmpdump"
                cmd2 = "killall -9 wget"
                os.system(cmd1)
                os.system(cmd2)
                self.close()

 
    def keyLeft(self):
		self["text"].left()
	
    def keyRight(self):
		self["text"].right()

    def keyNumberGlobal(self, number):
		#print "pressed", number
		self["text"].number(number)
		

		
		
                               
#################################                                                                                    
                                             

#################################################

def main(session, **kwargs):
	session.open(SF)

def Plugins(**kwargs):
	return [
		PluginDescriptor(name = "SFVideoPortal", description = _("SF Video Player"), where = PluginDescriptor.WHERE_PLUGINMENU, fnc = main),
		PluginDescriptor(name = "SFVideoPortal", description = _("SF Video Player"), where = PluginDescriptor.WHERE_EXTENSIONSMENU, fnc=main)]


